<template>
    <div class="mb-5">
        <div class="row">
            <div class="login__form  col-6 offset-3">
                <form class="bg-white border rounded p-4">
                    <div class="form-group">
                        <label for="name">Name</label>
                        <input type="text" class="form-control" id="name" v-model="form.name"
                               :class="{'is-invalid' : $v.form.name.$error }"
                               @input="$v.form.name.$touch"
                               placeholder="Your name">
                        <div v-if="$v.form.name.$error" class="invalid-feedback">
                            Name is required.
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="email">Email address</label>
                        <input type="email" class="form-control" id="email" v-model="form.email"
                               :class="{'is-invalid' : $v.form.email.$error }"
                               @input="$v.form.email.$touch"
                               aria-describedby="emailHelp" placeholder="Enter email address">
                        <div v-if="$v.form.email.$error" class="invalid-feedback">
                            Valid email is required.
                        </div>
                        <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone
                            else.</small>
                    </div>
                    <div class="form-group">
                        <label for="password">Password</label>
                        <input type="password" class="form-control" id="password" placeholder="Password"
                               :class="{'is-invalid' : $v.form.password.$error }"
                               @input="$v.form.password.$touch"
                               v-model="form.password">
                        <div v-if="$v.form.password.$error" class="invalid-feedback">
                            Valid password with minimum 6 character is required.
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="password">Password</label>
                        <input type="password" class="form-control" id="confirm_password" placeholder="Confirm password"
                               :class="{'is-invalid' : $v.form.confirm_password.$error }"
                               @input="$v.form.confirm_password.$touch"
                               v-model="form.confirm_password">
                        <div v-if="$v.form.confirm_password.$error" class="invalid-feedback">
                            This field is not the same as password.
                        </div>
                    </div>
                    <button type="submit" :disabled="$v.form.$invalid"
                            :class="{ disabled : $v.form.$invalid}" class="btn btn-block btn-info" @click.prevent="register()">Register
                    </button>
                    <div>
                        <small v-if="$v.form.$error" class="text-danger">
                            Please check the form again.
                        </small>
                        <small v-if="status==='ERROR'" class="text-danger">
                            Something went wrong. Please try again
                        </small>
                    </div>
                    <div class="text-center mt-1">
                        Alread have an account?
                        <router-link to="/login">Login</router-link>


                    </div>
                </form>
            </div>
        </div>

    </div>
</template>

<script>
    import {required, email, minLength, sameAs} from 'vuelidate/lib/validators'

    export default {
        name: "Register",
        validations: {
            form: {
                email: {
                    required,
                    email
                },
                name: {
                    required,
                },
                password: {
                    required,
                    minLength: minLength(6)
                },
                confirm_password: {
                    required,
                    sameAsPassword: sameAs('password')
                }
            }

        },
        data() {
            return {
                form: {},
                status: 'SAVED'
            }
        },

        methods: {
            register() {
                let data = this.form;
                this.$http.post('register', data)
                    .then((response) => {
                        let token = response.data.data.access_token;
                        localStorage.setItem('token', token);
                        this.$router.push('/')
                    }).catch((e) => {
                this.status = "ERROR"
                });

            }
        }
    }
</script>

<style scoped>

</style>
